#include "arduino.h"
#include <FastLED.h>
#define NUM_LEDS 144
#define LedLeg 8
#define NUM_LEDS_LONGLEG 20
#define NUM_LEDS_SHORTLEG 16
#define MAX_POWER_MILLIAMPS 50
#define LED_TYPE WS2812B
#define COLOR_ORDER GRB
//#include <avr/power.h>     // only needed for LGT8 board
#define FRAMES_PER_SECOND 10
uint8_t Brightness = 20;
int t = 100;

CRGB leds[LedLeg][NUM_LEDS_LONGLEG];

//CRGBPalette16 currentPalette(CRGB::Black);    // removed, don't seem to do much
//CRGBPalette16 targetPalette(OceanColors_p);
CRGBPalette16 gPal; // This first palette is the basic 'black body radiation' colors,
// which run from black to red to bright yellow to white.
void setup()
{
  //clock_prescale_set(clock_div_1);      // only needed for LGT8 board
  Serial.begin(115200);
  FastLED.addLeds<LED_TYPE, 2, GRB>(leds[0], NUM_LEDS_LONGLEG).setCorrection(TypicalLEDStrip);
  FastLED.addLeds<LED_TYPE, 3, GRB>(leds[1], NUM_LEDS_SHORTLEG).setCorrection(TypicalLEDStrip);
  FastLED.addLeds<LED_TYPE, 4, GRB>(leds[2], NUM_LEDS_LONGLEG).setCorrection(TypicalLEDStrip);
  FastLED.addLeds<LED_TYPE, 5, GRB>(leds[3], NUM_LEDS_SHORTLEG).setCorrection(TypicalLEDStrip);
  FastLED.addLeds<LED_TYPE, 6, GRB>(leds[4], NUM_LEDS_LONGLEG).setCorrection(TypicalLEDStrip);
  FastLED.addLeds<LED_TYPE, 7, GRB>(leds[5], NUM_LEDS_SHORTLEG).setCorrection(TypicalLEDStrip);
  FastLED.addLeds<LED_TYPE, 8, GRB>(leds[6], NUM_LEDS_LONGLEG).setCorrection(TypicalLEDStrip);
  FastLED.addLeds<LED_TYPE, 9, GRB>(leds[7], NUM_LEDS_SHORTLEG).setCorrection(TypicalLEDStrip);

  FastLED.setMaxPowerInVoltsAndMilliamps(200, MAX_POWER_MILLIAMPS);
}

void loop()
{
  static boolean r = 0;
  Serial.print(" Brightness is : ");
  Serial.print(Brightness);

  Pacifica();
  Serial.print(" Brightness is : ");
  Serial.println(Brightness);
  Twinkle_Fox();
  Serial.print(" Brightness is : ");
  Serial.println(Brightness);
  Circle();
  Serial.print(" Brightness is : ");
  Serial.println(Brightness);
  Cylon();
  Serial.print(" Brightness is : ");
  Serial.println(Brightness);
  Pride();
  Serial.print(" Brightness is : ");
  Serial.println(Brightness);
  windmill();
  Serial.print(" Brightness is : ");
  Serial.println(Brightness);
  Fire();
  Serial.print(" Brightness is : ");
  Serial.println(Brightness);
  Serial.println("  ---  Circling ----");

  if ( r == 0)
  {
    Brightness = Brightness + 10;
  }
  if ( Brightness > 70)
  {
    r = 1;
  }
  if ( r == 1)
  {
    Brightness = Brightness - 10;
  }
  if (Brightness < 10)
  {
    Brightness = 20;
    r = 0;
  }
}

void Fire()
{

  static byte Q = 1;
  Serial.print(" -----------------Fire burning --------- ");
  Serial.println(Q);
  for (int i = 0; i < 2400; i++)
  {
    if (Q == 1)
    {
      gPal = HeatColors_p;
    }
    // These are other ways to set up the color palette for the 'fire'.
    // First, a gradient from black to red to yellow to white -- similar to HeatColors_p
    if (Q == 2)
    {
      gPal = CRGBPalette16(CRGB::Black, CRGB::Green, CRGB::Yellow, CRGB::White);
    }

    // Second, this palette is like the heat colors, but blue/aqua instead of red/yellow
    if (Q == 3)
    {
      gPal = CRGBPalette16(CRGB::Black, CRGB::Blue, CRGB::Aqua, CRGB::White);
    }

    // Third, here's a simpler, three-step gradient, from black to red to white
    if (Q == 4)
    {
      gPal = CRGBPalette16(CRGB::Black, CRGB::Red, CRGB::Blue);
    }
    // Fire2012 with programmable Color Palette
    //
    // This code is the same fire simulation as the original "Fire2012",
    // but each heat cell's temperature is translated to color through a FastLED
    // programmable color palette, instead of through the "HeatColor(...)" function.
    //
    // Four different static color palettes are provided here, plus one dynamic one.
    //
    // The three static ones are:
    //   1. the FastLED built-in HeatColors_p -- this is the default, and it looks
    //      pretty much exactly like the original Fire2012.
    //
    //  To use any of the other palettes below, just "uncomment" the corresponding code.
    //
    //   2. a gradient from black to red to yellow to white, which is
    //      visually similar to the HeatColors_p, and helps to illustrate
    //      what the 'heat colors' palette is actually doing,
    //   3. a similar gradient, but in blue colors rather than red ones,
    //      i.e. from black to blue to aqua to white, which results in
    //      an "icy blue" fire effect,
    //   4. a simplified three-step gradient, from black to red to white, just to show
    //      that these gradients need not have four components; two or
    //      three are possible, too, even if they don't look quite as nice for fire.
    //
    // The dynamic palette shows how you can change the basic 'hue' of the
    // color palette every time through the loop, producing "rainbow fire".

    // Add entropy to random number generator; we use a lot of it.
    random16_add_entropy(random());

    // Fourth, the most sophisticated: this one sets up a new palette every
    // time through the loop, based on a hue that changes every time.
    // The palette is a gradient from black, to a dark color based on the hue,
    // to a light color based on the hue, to white.
    //
    static uint8_t hue = 0;
    hue++;
    CRGB darkcolor = CHSV(hue, 255, 192);  // pure hue, three-quarters brightness
    CRGB lightcolor = CHSV(hue, 128, 255); // half 'whitened', full brightness
    if (Q == 5)
    {
      gPal = CRGBPalette16(CRGB::Black, darkcolor, lightcolor, CRGB::White);
    }
    Fire2012WithPalette(i); // run simulation frame, using palette colors

    FastLED.show(); // display this frame
    FastLED.delay(1000 / FRAMES_PER_SECOND);
  }
  Q++;
  if (Q > 5)
  {
    Q = 1;
  }
}
// Fire2012 by Mark Kriegsman, July 2012
// as part of "Five Elements" shown here: http://youtu.be/knWiGsmgycY
////
// This basic one-dimensional 'fire' simulation works roughly as follows:
// There's a underlying array of 'heat' cells, that model the temperature
// at each point along the line.  Every cycle through the simulation,
// four steps are performed:
//  1) All cells cool down a little bit, losing heat to the air
//  2) The heat from each cell drifts 'up' and diffuses a little
//  3) Sometimes randomly new 'sparks' of heat are added at the bottom
//  4) The heat from each cell is rendered as a color into the leds array
//     The heat-to-color mapping uses a black-body radiation approximation.
//
// Temperature is in arbitrary units from 0 (cold black) to 255 (white hot).
//
// This simulation scales it self a bit depending on NUM_LEDS_LONGLEG; it should look
// "OK" on anywhere from 20 to 100 LEDs without too much tweaking.
//
// I recommend running this simulation at anywhere from 30-100 frames per second,
// meaning an interframe delay of about 10-35 milliseconds.
//
// Looks best on a high-density LED setup (60+ pixels/meter).
//
//
// There are two main parameters you can play with to control the look and
// feel of your fire: COOLING (used in step 1 above), and SPARKING (used
// in step 3 above).
//
// COOLING: How much does the air cool as it rises?
// Less cooling = taller flames.  More cooling = shorter flames.
// Default 55, suggested range 20-100
//#define COOLING 100
// SPARKING: What chance (out of 255) is there that a new spark will be lit?
// Higher chance = more roaring fire.  Lower chance = more flickery fire.
// Default 120, suggested range 50-200.
//#define SPARKING 80

void Fire2012WithPalette(int i)
{
  static byte COOLING = 150;
  static byte SPARKING = 15;
  static byte CoolCount = 1;
  static byte SparkCount = 1;

  if (CoolCount > 7)
  {
    if (i < 1200)
    {
      COOLING--;
      CoolCount = 0;
      if (COOLING < 15)
      {
        COOLING = 15;
      }
    }
    else
    {
      COOLING++;
      CoolCount = 0;
      if (COOLING > 150)
      {
        COOLING = 150;
      }
    }
  }
  if (SparkCount > 9)
  {
    if (i > 200 & i < 1200)
    {
      //Serial.print("---------------------  i is now ");
      //Serial.println(i);
      SPARKING++;
      SparkCount = 0;
      if (SPARKING > 225)
      {
        SPARKING = 225;
      }
    }
    if (i > 1200)
    {
      // Serial.print("--------------------- sparkie going down , i is now ");
      //Serial.println(i);
      SPARKING--;
      SparkCount = 0;
      if (SPARKING < 20)
      {
        SPARKING = 20;
      }

    }
  }
  SparkCount++;
  CoolCount++;

  LEDS.setBrightness(Brightness);
  bool gReverseDirection = false;
  // Array of temperature readings at each simulation cell
  static byte heat[NUM_LEDS_LONGLEG];

  // Step 1.  Cool down every cell a little
  for (int i = 0; i < NUM_LEDS_LONGLEG; i++)
  {
    heat[i] = qsub8(heat[i], random8(0, ((COOLING * 10) / NUM_LEDS_LONGLEG) + 2));
  }

  // Step 2.  Heat from each cell drifts 'up' and diffuses a little
  for (int k = NUM_LEDS_LONGLEG - 1; k >= 2; k--)
  {
    heat[k] = (heat[k - 1] + heat[k - 2] + heat[k - 2]) / 3;
  }

  // Step 3.  Randomly ignite new 'sparks' of heat near the bottom
  if (random8() < SPARKING)
  {
    int y = random8(7);
    heat[y] = qadd8(heat[y], random8(160, 255));
  }

  // Step 4.  Map from heat cells to LED colors
  for (int j = 0; j < NUM_LEDS_LONGLEG; j++)
  {
    // Scale the heat value from 0-255 down to 0-240
    // for best results with color palettes.
    byte colorindex = scale8(heat[j], 240);
    CRGB color = ColorFromPalette(gPal, colorindex);
    int pixelnumber;
    if (gReverseDirection)
    {
      pixelnumber = (NUM_LEDS_LONGLEG - 1) - j;
    }
    else
    {
      pixelnumber = j;
    }
    for (int leg = 0; leg < 8; leg++)
    {
      leds[leg][pixelnumber] = color;
    }
  }
}

void Cylon()
{
  uint8_t  BrightnessOld; 
  BrightnessOld = Brightness;
  Serial.println( "-------------------------- Cylon -------------------");
  byte Legs[8] = {0, 1, 2, 3, 4, 5, 6, 7};
  LEDS.setBrightness(Brightness);
  int t = 0;
  //int r = 2;
  byte y = 0;
  byte q = 1;
  bool Double1 = 0, Double2 = 0, Fade1, Fade2, Fade3, Fade4;
  for (byte T = 0; T < 20; T++)
  {
    for (byte x = 0; x < 8; x++)
    {
      q = (x + 4) % 8;
      if (T < 2)

      {

        Fade1 = 1;
        Fade2 = 1;
        Fade3 = 1;
        Fade4 = 1;
        Double1 = 0;
        Double2 = 0;
      }
      if (T == 2)
      {
        Fade3 = 0;
      }

      if (T == 5)
      {
        Fade1 = 0;
        Fade2 = 0;
      }

      if (T == 7)

      {
        q = (x + 1) % 8;
        Double2 = 1;
      }
      if (T == 10)
      {
        q = (x + 4) % 8;
        Fade1 = 1;
        Fade2 = 1;
        Fade3 = 1;
        Fade4 = 1;
      }
      if (T == 13)
      {
        Fade3 = 1;
        Fade4 = 1;
        Double1 = 1;
      }
      if (T == 16)
      {
        Double1 = 0;
        Double2 = 0;
        Fade1 = 0;
        Fade2 = 0;
        Fade3 = 0;
        Fade4 = 0;
      }
      if (T > 18)
      {
        Brightness += 5;
        LEDS.setBrightness(Brightness);
      }
      if (T == 19)
      {
        Fade2 = 0;
      }

      Slide_In(Legs[x], t, Fade1, Double1);
      Slide_Out(Legs[q], t, Fade2, Double1);
      Slide_In(Legs[q], t, Fade3, Double2);
      Slide_Out(Legs[x], t, Fade4, Double2);
    }

    if (T < 10)
    {
      t++;
    }
    if (T > 15)
    {
      t = 0;
    }
    //Serial.print(" T is now : ");
    //Serial.println(T);
    if (T > 20)
    {
      // Serial.print(" end program ");
      return;
    }
  }
  Brightness = BrightnessOld;
}

void Slide_Out(byte leg, byte timer, boolean Fade, bool Double) // First slide the led in one direction
{
  static uint8_t hue = 0;
  for (int i = 0; i < NUM_LEDS_LONGLEG; i++)
  {
    // Set the i'th led to red
    byte leg2 = (leg + 6) % 8;
    leds[leg][i] = CHSV(hue++, 255, 255);
    if (Double == 1)
    {
      leds[leg2][i] = CHSV(hue++, 255, 255);
    }
    // Show the leds
    FastLED.show();
    // now that we've shown the leds, reset the i'th led to black
    if (Fade == 1)
    {
      leds[leg][i] = CRGB::Black;
      fadeall(leg);
      delay(timer);
    }
  }
}

void Slide_In(byte leg, byte timer, boolean Fade, bool Double) // Now go in the other direction.
{
  static uint8_t hue = 0;
  for (int i = (NUM_LEDS_LONGLEG) - 1; i >= 0; i--)
  {
    byte leg2 = (leg + 6) % 8;
    leds[leg][i] = CHSV(hue++, 255, 255);
    if (Double == 1)
    {
      leds[leg2][i] = CHSV(hue++, 255, 255);
    }
    // Show the leds
    FastLED.show();
    // now that we've shown the leds, reset the i'th led to black
    if (Fade == 1)
    {
      leds[leg][i] = CRGB::Black;
      fadeall(leg);
    }
    // Wait a little bit before we loop around and do it again
    delay(timer);
  }
}
void fadeall(byte q)
{
  for (int i = 0; i < NUM_LEDS_LONGLEG; i++)
  {
    leds[q][i].nscale8(250);
  }
}

void Circle()
{
  Serial.println( "-------------------------- Circle -------------------");
  static int q;

  static byte Hue;
  static byte Sat;
  static byte SatPlus = 2;
  static byte Bright = 20;
  int HuePlus = 2;
  int BrightPlus = 2;
  for (byte y = 0; y < 30; y++)
  {

    for (int i = 0; i < NUM_LEDS_LONGLEG; i++)
    {
      for (int leg = 0; leg < LedLeg; leg++)
      {
        leds[leg][i] = CHSV(Hue, Sat, Bright);
        Hue = Hue + HuePlus;
        if (Hue > 250)
        {
          HuePlus = HuePlus * -1;
        }
        if (Hue < -1)
        {
          HuePlus = HuePlus * -1;
        }

        Sat = Sat + SatPlus;
        if (Sat > 250)
        {
          SatPlus = SatPlus * -1;
        }
        if (Sat < 0)
        {
          SatPlus = SatPlus * -1;
        }
        FastLED.show();
        // clear this led for the next time around the loop
        leds[leg][i] = CRGB::Black;
        Sat++;
        if (t < 0)
        {
          t = 0;
        }
        delay(t);

        Bright = Bright + BrightPlus;
        if (Bright > 500)
        {
          BrightPlus = BrightPlus * -1;
        }
        if (Bright < 20)
        {
          BrightPlus = BrightPlus * -1;
        }
      }

      t = t - 1;
    }
    q++;
  }
}
//
//  "Pacifica"
//  Gentle, blue-green ocean waves.
//  December 2019, Mark Kriegsman and Mary Corey March.
//  For Dan.
//

void Pacifica()
{
  Serial.println( "-------------------------- Pacifica -------------------");
  LEDS.setBrightness(Brightness);
  for (long i = 0; i < 50000000; i++)
  {
    EVERY_N_MILLISECONDS(20)
    {

      pacifica_loop();
      Copy_Legs();
      FastLED.show();
    }
  }
}

//////////////////////////////////////////////////////////////////////////
//
// The code for this animation is more complicated than other examples, and
// while it is "ready to run", and documented in general, it is probably not
// the best starting point for learning.  Nevertheless, it does illustrate some
// useful techniques.
//
//////////////////////////////////////////////////////////////////////////
//
// In this animation, there are four "layers" of waves of light.
//
// Each layer moves independently, and each is scaled separately.
//
// All four wave layers are added together on top of each other, and then
// another filter is applied that adds "whitecaps" of brightness where the
// waves line up with each other more.  Finally, another pass is taken
// over the led array to 'deepen' (dim) the blues and greens.
//
// The speed and scale and motion each layer varies slowly within independent
// hand-chosen ranges, which is why the code has a lot of low-speed 'beatsin8' functions
// with a lot of oddly specific numeric ranges.
//
// These three custom blue-green color palettes were inspired by the colors found in
// the waters off the southern coast of California, https://goo.gl/maps/QQgd97jjHesHZVxQ7
//
CRGBPalette16 pacifica_palette_1 =
{ 0x000507, 0x000409, 0x00030B, 0x00030D, 0x000210, 0x000212, 0x000114, 0x000117,
  0x000019, 0x00001C, 0x000026, 0x000031, 0x00003B, 0x000046, 0x14554B, 0x28AA50
};
CRGBPalette16 pacifica_palette_2 =
{ 0x000507, 0x000409, 0x00030B, 0x00030D, 0x000210, 0x000212, 0x000114, 0x000117,
  0x000019, 0x00001C, 0x000026, 0x000031, 0x00003B, 0x000046, 0x0C5F52, 0x19BE5F
};
CRGBPalette16 pacifica_palette_3 =
{ 0x000208, 0x00030E, 0x000514, 0x00061A, 0x000820, 0x000927, 0x000B2D, 0x000C33,
  0x000E39, 0x001040, 0x001450, 0x001860, 0x001C70, 0x002080, 0x1040BF, 0x2060FF
};
void Copy_Legs()
{
  for (int leg = 0; leg < LedLeg; leg++)
  {
    for (int x = 0; x < NUM_LEDS_LONGLEG; x++)
    {
      leds[leg][x] = leds[0][x];
    }
  }
}
void pacifica_loop()
{
  // Increment the four "color index start" counters, one for each wave layer.
  // Each is incremented at a different speed, and the speeds vary over time.
  static uint16_t sCIStart1, sCIStart2, sCIStart3, sCIStart4;
  static uint32_t sLastms = 0;
  uint32_t ms = GET_MILLIS();
  uint32_t deltams = ms - sLastms;
  sLastms = ms;
  uint16_t speedfactor1 = beatsin16(3, 179, 269);
  uint16_t speedfactor2 = beatsin16(4, 179, 269);
  uint32_t deltams1 = (deltams * speedfactor1) / 256;
  uint32_t deltams2 = (deltams * speedfactor2) / 256;
  uint32_t deltams21 = (deltams1 + deltams2) / 2;
  sCIStart1 += (deltams1 * beatsin88(1011, 10, 13));
  sCIStart2 -= (deltams21 * beatsin88(777, 8, 11));
  sCIStart3 -= (deltams1 * beatsin88(501, 5, 7));
  sCIStart4 -= (deltams2 * beatsin88(257, 4, 6));

  // Clear out the LED array to a dim background blue-green
  fill_solid(leds[0], NUM_LEDS_LONGLEG, CRGB(2, 6, 10));

  // Render each of four layers, with different scales and speeds, that vary over time
  pacifica_one_layer(pacifica_palette_1, sCIStart1, beatsin16(3, 11 * 256, 14 * 256), beatsin8(10, 70, 130), 0 - beat16(301));
  pacifica_one_layer(pacifica_palette_2, sCIStart2, beatsin16(4, 6 * 256, 9 * 256), beatsin8(17, 40, 80), beat16(401));
  pacifica_one_layer(pacifica_palette_3, sCIStart3, 6 * 256, beatsin8(9, 10, 38), 0 - beat16(503));
  pacifica_one_layer(pacifica_palette_3, sCIStart4, 5 * 256, beatsin8(8, 10, 28), beat16(601));

  // Add brighter 'whitecaps' where the waves lines up more
  pacifica_add_whitecaps();

  // Deepen the blues and greens a bit
  pacifica_deepen_colors();
}

// Add one layer of waves into the led array
void pacifica_one_layer(CRGBPalette16 &p, uint16_t cistart, uint16_t wavescale, uint8_t bri, uint16_t ioff)
{
  uint16_t ci = cistart;
  uint16_t waveangle = ioff;
  uint16_t wavescale_half = (wavescale / 2) + 20;
  for (uint16_t i = 0; i < NUM_LEDS_LONGLEG; i++)
  {
    waveangle += 250;
    uint16_t s16 = sin16(waveangle) + 32768;
    uint16_t cs = scale16(s16, wavescale_half) + wavescale_half;
    ci += cs;
    uint16_t sindex16 = sin16(ci) + 32768;
    uint8_t sindex8 = scale16(sindex16, 240);
    CRGB c = ColorFromPalette(p, sindex8, bri, LINEARBLEND);
    leds[0][i] += c;
  }
}

// Add extra 'white' to areas where the four layers of light have lined up brightly
void pacifica_add_whitecaps()
{
  uint8_t basethreshold = beatsin8(9, 55, 65);
  uint8_t wave = beat8(7);

  for (uint16_t i = 0; i < NUM_LEDS_LONGLEG; i++)
  {
    uint8_t threshold = scale8(sin8(wave), 20) + basethreshold;
    wave += 7;
    uint8_t l = leds[0][i].getAverageLight();
    if (l > threshold)
    {
      uint8_t overage = l - threshold;
      uint8_t overage2 = qadd8(overage, overage);
      leds[0][i] += CRGB(overage, overage2, qadd8(overage2, overage2));
    }
  }
}

// Deepen the blues and greens
void pacifica_deepen_colors()
{
  for (uint16_t i = 0; i < NUM_LEDS_LONGLEG; i++)
  {
    leds[0][i].blue = scale8(leds[0][i].blue, 145);
    leds[0][i].green = scale8(leds[0][i].green, 200);
    leds[0][i] |= CRGB(2, 5, 7);
  }
}
void windmill()
{
  int Time = 1000;
  Serial.println( "-------------------------- windmill -------------------");
  static byte R = 25;
  static byte G = 68;
  static byte B = 221;

  LEDS.setBrightness(Brightness);

  for (int T = 0; T < 20; T++)
  {
    // This outer loop will go over each strip, one at a time
    for (int x = 0; x < LedLeg; x++)
    {
      //delay(25);
      static int y = x + 3;
      y++;
      if (y > 7)
      {
        y = 0;
      }
      // This inner loop will go over each led in the current strip, one at a time
      for (int i = 0; i < NUM_LEDS_LONGLEG; i++)
      {
        leds[x][i].setRGB(R, G, B);
        leds[y][i].setRGB(G, B, R);
      }
      FastLED.show();
      //delay(10);
      for (int i = 0; i < NUM_LEDS_LONGLEG; i++)
      {
        leds[x][i] = CRGB::Black;
        leds[y][i] = CRGB::Black;
      }
      //FastLED.show();
      delay(Time);
      Time = Time - 20;
      if (Time < 50)
      {
        Time = 50;
      }
    }
  }
  R += 25 % 255;
  G += 33 % 255;
  B += 48 % 255;
}
